	
	iG_Image = function(Name, Data, External)
	{
		this.ThumbMode = "ST";
		this.Acturl = parent.G_PS_BlogPath+"/wp-admin/admin-ajax.php";
		this.Processing = "http://www.picturesurf.org/img/ST_processing.gif";
		this.InList = [];
		this.Thumbnails = {};
		this.ImageThumbs = [];
		this.Name = Name;
		this.Iid = "";
		this.Title = "";
		this.Descr = "";
		this.Tags = [];
		if(!Data)
			Data = {};
		this._loadJson(Data);
		this._saveAddables();
		if(!External)
			this.createThumb();
	};
	iG_Image.prototype.createThumb = function(Modes, Width, dataOnly)
	{
		if(!Modes)
			Modes = [this.ThumbMode];
		if(!Width)
			Width = 0;
		var Nmodes = [];
		for(var I=0; I<Modes.length; I++) //check if thumbnail alrady exists
			if(!this.Thumbnails[Modes[I]] || Modes[I]=='custom')
			{
				Nmodes.push(Modes[I]);
			}
		if(Nmodes.length)
		{
			if(top.G_PS_GDEnabled)
			{
				if(dataOnly)
					return '{"id": ' + this.Iid + ', "url": "' + rawEscape(this.Mainsrc) + '", "modes": ["' + Nmodes.join('","') + '"], "width": ' + Width + '}';
				var Images = '[{"id": ' + this.Iid + ', "url": "' + rawEscape(this.Mainsrc) + '", "modes": ["' + Nmodes.join('","') + '"], "width": ' + Width + '}]';
				var Data = "action=PSthumbnailImage&images=" + Images;
				$jQ.post(this.Acturl, Data, SWFP_onThumbnailComplete);
			}
			else
			{
				if(dataOnly)
					return {"url": this.Mainsrc, "id": this.Iid};
				G_PS_ImProcessor.createThumbnails([{"url": this.Mainsrc, "id": this.Iid}], Nmodes, Width);
			}
		}
	};
	iG_Image.prototype._acceptThumb = function(Data)
	{
		if(Data.thumbnails)
		{
			for (var Mode in Data.thumbnails)
			{
				this.Thumbnails[Mode] = Data.thumbnails[Mode];
				if(Mode == this.ThumbMode)
					this._updateThumb();
			}
		}
		if(this.onComplete)
		{
			this.onComplete();
			this.onComplete = null;
		}
	};
	iG_Image.prototype._updateThumb = function()
	{
		for(var I=0; I<this.ImageThumbs.length; I++)
			this.ImageThumbs[I].I.attr("src", this.Thumbnails[this.ThumbMode]);
	};
	/*
	iG_Image.prototype.loadOriginal = function()
	{
		this.thumbsrc = this.Processing;
		this._updateThumb();
		var that = this;
		var onFail = function()
		{
			that.loadOriginal(); //repeat creation;
		};
		var onReady = function()
		{
			var status = null;
			try{eval(this.response.text)} catch(e)
			{
				Noter.display("Error importing original file.");
				that.destroy();
				return;
			};
			if(status)
			{
				if(status.status=="ok")
				{
					that.Iid = status.Iid;
					that.Thumbnails = status.Thumbnails;
					that.Mainsrc = status.Thumbnails.orig;
					that._updateThumb();
					if(that.oncomplete)
						that.oncomplete();
				}
				else
				{
					Noter.display(status.message);
					that.destroy();
					if(that.oncomplete)
						that.oncomplete();					
				}
			}
		};
		var Data = "action=loadOriginal&url="+rawEscape(this.origurl)+"&source="+rawEscape(this.source);
		var aj = new Request({url: this.Acturl, onFailure: onFail, onSuccess: onReady }).send(Data);
	};
	*/
	iG_Image.prototype.drawThumb = function(onselect, Opacity)
	{
		var that = this;
		var Thbox = $jQ('<p class="b-image-link"></p>');
		var Thumbsrc = this.Thumbnails[this.ThumbMode]?this.Thumbnails[this.ThumbMode]:this.Processing;
		Thbox.Opacity = Opacity;
		if(!Opacity)
			Opacity = this._getOpacity();
		Thbox.P = $jQ('<a href="#"></a>').appendTo(Thbox);
		Thbox.Si = $jQ('<span class="image-holder"></span>').appendTo(Thbox.P);
		Thbox.I = $jQ('<img src="' + Thumbsrc + '" height="72" alt=""/>').css({opacity: Opacity}).appendTo(Thbox.Si);
		Thbox.S = $jQ('<span class="image-Title"></span>').css({display: (this.Title?"inline":"none")}).appendTo(Thbox.P);
		Thbox.S.html(this.Title);
		Thbox.P.mousedown(function(e)
		{
			if(typeof(onselect) == "function")
				onselect(that, e);
		});
		Thbox.P.click(function(e){ e.stopPropagation(); return false; }); // ???
		Thbox.get(0).Main = this;
		this.ImageThumbs.push(Thbox);
		return Thbox;
	};
	iG_Image.prototype._getOpacity = function()
	{
		var Opacity = 50;
		if(this.Title)
			Opacity+=15;
		if(this.Descr)
			Opacity+=15;
		if(this.Tags.length > 0)
			Opacity+=15;
		return Opacity/100;
	};
	iG_Image.prototype.updateRichness = function()
	{
		if(!this.Edtthmb || this.Edtthmb.hasClass("selected"))
			return;
		var Opacity = this._getOpacity();
		for(var I=0; I<this.ImageThumbs.length; I++)
			if(!this.ImageThumbs[I].Opacity)
				this.ImageThumbs[I].I.css("opacity", Opacity);
		this._saveAddables();
	};
	iG_Image.prototype._saveAddables = function()
	{
		this.Sdescr = this.Descr;
		this.Stags = $jQ.extend([], this.Tags);
	};
	iG_Image.prototype.setTitle = function(Title)
	{
		this.Title = Title;
		for(var I=0; I<this.ImageThumbs.length; I++)
		{
			this.ImageThumbs[I].S.html(Title);
			this.ImageThumbs[I].S.css("display", (this.Title?"inline":"none"));
		}
		this.updateRichness();
	};
	iG_Image.prototype.setDescr = function(Descr)
	{
		this.Descr = Descr;
		this.updateRichness();
	};
	iG_Image.prototype.setTags = function(Tags)
	{
		if(!Tags)
			this.Tags = [];
		else if(typeof(Tags) != "array")
			this.Tags = [unescape(Tags)];
		else 
		{
			//NOTE for some reason tags array gets cleared and for other images
			$jQ.arrayRemove("", Tags);
			this.Tags = Tags;
		}
		for(var I=0; I<this.Tags.length; I++)
			this.Tags[I] = unescape(this.Tags[I]);
		this.updateRichness();
	};
	iG_Image.prototype._getJson = function()
	{
		var json = "{ \"name\": \""+rawEscape(this.Name)+"\"";
		json+= ", \"id\": \""+this.Iid+"\"";
		json+= ", \"src\": \""+this.Mainsrc+"\"";
		json+= ", \"title\": \""+rawEscape(this.Title)+"\"";
		json+= ", \"descr\": \""+rawEscape(this.Descr.replace(/[\r\n]/g, "<br/>"))+"\"";
		var tagstr = "[";
		for(var I=0; I<this.Tags.length; I++)
			tagstr+=(I==0?"":", ")+"\""+rawEscape(this.Tags[I])+"\"";
		tagstr+= "]";
		json+= ", \"tags\": "+tagstr;
		json+= ", \"destroyed\": "+(this.Destroyed?"true":"false");
		json+= ", \"thumbnails\": "+toJson(this.Thumbnails);
		if(this.StockMode)
			json+= ", \"StockMode\": \""+this.StockMode+"\"";
		if(this.StockParam)
			json+= ", \"StockParam\": \""+this.StockParam+"\"";
		if(this.StockAdd)
			json+= ", \"StockAdd\": \""+this.StockAdd+"\"";
		json+= "}";
		return json;
	};
	iG_Image.prototype._loadJson = function(Data)
	{
		this.Data = Data;
		if(Data.id)
			this.Iid = Data.id;
		if(Data.src)
			this.Mainsrc = Data.src;
		else
			this.Mainsrc = "uploads/"+this.Name
		if(Data.title)
			this.setTitle(unescape(Data.title));
		if(Data.descr)
			this.setDescr(unescape(Data.descr.replace("<br/>", "\r\n")));
		if(Data.tags)
			this.setTags(Data.tags);
		if(Data.destroyed)
			this.Destroyed = Data.destroyed;
		if(Data.thumbnails)
			this.Thumbnails = Data.thumbnails;
		if(Data.StockMode)
			this.StockMode = Data.StockMode;
		if(Data.StockParam)
			this.StockParam = Data.StockParam;
		if(Data.StockAdd)
			this.StockAdd = Data.StockAdd;
		if(!this.Mainsrc || this.Mainsrc == 'undefined')
		{
			if(this.Thumbnails.original)
				this.Mainsrc = this.Thumbnails.original;
			if(this.Thumbnails.orig)
				this.Mainsrc = this.Thumbnails.orig;
		}
		this.views = Data.views?unescape(Data.views):0;
		this.date = Data.date?unescape(Data.date):"";
	};
	iG_Image.prototype.destroy = function()
	{
		if(this.ondestroy)
			this.ondestroy();
		$jQ(this.ImageThumbs).each(function(I, El){ El.remove(); });
		$jQ(this.InList).each(function(I, Li){ Li.remove(); });
		this.Destroyed = true;
	};