	//var G_PS_ImProcessor = (document["ImageLib"]?document["ImageLib"]:window["ImageLib"]);

/* imageLib thumbnailing complete handlers */
	function SWFP_onThumbnailComplete(results)
	{
		var status = null;
		try{ eval('status = '+results) }catch(E){ return; }
		if (!status) 
		{
			Noter.display('Oops! We\'re having some problems. <a href="contact@picturesurf.org">Please tell us more</a>.');
			return;
		}
		if (status && status.status != "ok")
		{
			Noter.display(status.message);
			return;
		}
		var imgs = GalleryIns.Images;
		for (var I = 0; I < status.images.length; I++)
		{
			var itm = status.images[I];
			for (var J = 0; J < imgs.length; J++)
			{
				if (imgs[J].Iid == itm.id)
				{
					imgs[J]._acceptThumb(itm);
				}
			}
		}
	};

	var PSGallery = function()
	{
		var that = this;
		var _UI = null;
		var _BtnSave = null;
		var _Preview = null;
		var _PreviewDefaultData = null;
		var _EmbedBox = null;
		var _WidthBlock = null;
		var _WidthSel = null;
		var _Uploader = null;
		var _EditPane = null;
		var _SettingsPane = null;
		var _Gallery = {Title: null, TitleInpt: null, Gid: null, Datecr: null, Dateup: null, Code: null, ThumbArrangment: '5x5'};
		this.Acturl = parent.G_PS_BlogPath + "/wp-admin/admin-ajax.php";
		this.Images = []; //array of all added Images
		this.ActivePane = null;

		$jQ(window).ready(function(){ _init() });

		var _init = function()
		{
			if(window.GalleryIns && window.GalleryIns.isinited)
				return;
			_UI = $jQ('#psgallery-ui');
			_BtnSave = _UI.find("#psg-button-save").click(function(){ _export() });

			_Preview = iGW_list[0];
			_Preview.popupmode = true;
			_PreviewDefaultData = _Preview.data;
			_WidthBlock = _UI.find("#psgallery-width-block");
			_WidthBlock.Select = _WidthBlock.find("#psg-widthsel");
			_WidthBlock.WidthNote = _WidthBlock.find("#psg-widthnote");
			_WidthBlock.HideLnk = _WidthBlock.find("#psg-hidelink");
			_WidthBlock.Select.change(function()
			{
				_WidthBlock.WidthNote.html(this.value*_Preview.Dwidth/_Preview.cols);
				_WidthSel.val(this.value);
				_SettingsPane.getParams()['Width'].val(this.value);
				G_PS_GallerySettings['Width'] = this.value;
				that.setCols(this.value); 
			});
			_WidthBlock.HideLnk.click(function()
			{
				_WidthBlock.hideBox(); 
				return false;
			});
			_WidthBlock.showBox = function()
			{
				_WidthBlock.Select.val(5);
				_WidthBlock.WidthNote.html(_WidthBlock.Select.val()*_Preview.Dwidth/_Preview.cols);
				_WidthBlock.css('display', 'block');
			};
			_WidthBlock.hideBox = function()
			{
				_SettingsPane.save();
				_WidthBlock.css('display', 'none');
			};
			_WidthSel = _UI.find("#psg-gal-cols").change(function(){ that.setCols(this.value) });
			_Uploader = new SWFUpload({
				upload_url: G_PS_Path + "includes/upload.php",
				flash_url: G_PS_Path + "js/Swfupload.swf",
				file_types: "*.jpg;*.gif;*.png;*.jpeg",
				file_types_description: "Images",
				file_size_limit: "20480",
				file_upload_limit: "0",
				file_queue_limit: "0",
				post_params : {
					"saveDir": G_PS_DataDir
				},
				upload_progress_handler : function(File, BUpl, BTot)
				{
					var Stat = this.getStats();
					var Cmpl = Math.round(100*BUpl/BTot);
					Noter.display("Uploading file " + (File.index+1) + " of " + this.Total + " (" + Cmpl + "%)", "repl_uploader");
				},
				upload_complete_handler: function(File)
				{
					if(this.getStats().files_queued !== 0)
						this.startUpload();
					else
						Noter.display("Upload is complete", "repl_uploader");
				},
				upload_success_handler: function(File, Data)
				{
					try{eval("Data = "+Data);} catch(E){return;}
					_onUpload(Data);
				},
				file_dialog_complete_handler: function()
				{
					this.Total = this.getStats().files_queued;
					this.startUpload();
				},
				debug: false,
				button_placeholder_id: "psg-imgs-uploader",
				button_width: 67,
				button_height: 23,
				button_window_mode: "transparent"
			});
			_RemoveBtn = _UI.find("#psgallery-editpanel");
			_EditPane = new PSGalleryEditPane(_UI.find("#psg-edit"), that);
			_SettingsPane = new PSGallerySettingsPane(_UI.find("#psg-settings"), that);
			_FindPane = new PSGalleryFindPane(_UI.find("#psg-find"), that);
			_Gallery.TitleInpt = _UI.find("#psg-gal-title").keydown(function(E){ if(E.keyCode == 13){ return false; };})
			_Gallery.TitleInpt.blur( function(){that.save(true); window.clearInterval(_Gallery.TitleInpt.UpdIntr)} );
			_Gallery.TitleInpt.focus( function(){ _Gallery.TitleInpt.UpdIntr = window.setInterval( function(){that.save(true);}, 1500 ); } );
			_restore();
			_EditPane.open();
			this.isinited = true;
		};
		var _restore = function()
		{
			var Gallery = null;
			try{eval( G_PS_GallerySession )} catch(E){ Noter.display("Oops! We cannot find the Images from your gallery :("); }
			if(!G_PS_GallerySettings.IsSavedOnce)
				_WidthBlock.showBox();
			if(!Gallery || !Gallery.gid)
				_Gallery.Gid = '';
			if(!Gallery)
			{
				_restoreJson({data: {thar: G_PS_GallerySettings.Height + 'x' + G_PS_GallerySettings.Width}});
				that.updatePreview({data: {thar: G_PS_GallerySettings.Height + 'x' + G_PS_GallerySettings.Width}, ims: []});
				return;
			}
			_restoreJson(Gallery);
			for(var I=0; I<Gallery.ims.length; I++)
			{
				var Im = Gallery.ims[I];
				var Img = new iG_Image(Im.name, Im);
				Img.nosave = (I<Gallery.ims.length-1);
				that.registerImage(Img);
				if(Img.StockMode)
					_FindPane.insIntoList(Img.StockParam, Img.StockMode);
			}
			if(Gallery.code && Gallery.code != 'undefined')
				_updateEmbedBox(Gallery.code);
			that.save(true);
		};
		var _updateEmbedBox = function(Code)
		{
			if(!_EmbedBox)
			{
				_EmbedBox = _UI.find('#psg-code-block');
				_EmbedBox.Inp = _EmbedBox.find('#ecb_inpembed').keydown(function(E){ if(E.keyCode == 13){ return false; }});
			}
			if(_EmbedBox)
			{
				_EmbedBox.Inp.val('[PSGallery='+Code+']');
				_EmbedBox.css('display', 'block');
			}
		};
		var _saveJson = function()
		{
			var json = "\"title\": \"" + rawEscape(_Gallery.TitleInpt.val()) + "\"";
			json+= ", \"gid\": \"" + rawEscape(_Gallery.Gid) + "\"";
			json+= ", \"datecr\": \"" + _Gallery.Datecr + "\"";
			json+= ", \"dateup\": \"" + _Gallery.Dateup + "\"";
			if(_Gallery.Code)
				json+= ", \"code\": \"" + _Gallery.Code + "\"";
			json+= ", data: { ";
			json+= "\"thar\": \"" + _Gallery.ThumbArrangment + "\"";
			json+= " }";
			return json;
		};
		var _restoreJson = function(Data)
		{
			if(Data.title)
				_Gallery.TitleInpt.val(unescape(Data.title));
			if(Data.gid)
				_Gallery.Gid = unescape(Data.gid);
			if(Data.code)
				_Gallery.Code = unescape(Data.code);
			if(Data.datecr)
				_Gallery.Datecr = Data.datecr;
			if(Data.dateup)
				_Gallery.Dateup = Data.dateup;
			var D = Data.data;
			if(!D)
				return;
			this.NoSave = true;
			if(D.thar)
			{
				var Splt = D.thar.split('x');
				that.setRows(Splt[0], true);
				that.setCols(Splt[1], true);
				_Gallery.ThumbArrangment = D.thar;
			}
			this.NoSave = false;
		};
		var _onUpload = function(Data, onComplete)
		{
			if(!Data || !Data.stat)
			{
				Noter.display("Oops! We're having some technical difficulties. Please try again soon.");
				return;
			}
			if(Data.stat != "ok")
				Noter.display("Error uploading file. "+Data.message);
			else
			{
				var onAdd = function(Data)
				{
					var status = null;
					try{ eval(Data) }catch(E)
					{
						Noter.display("Oops! We're having some technical difficulties. Please try again soon.");
						return;
					}
					if(status && status.status!="ok")
					{
						Noter.display(status.message);
						return;
					}
					var T = status.name.split("."); T.pop(); T = T.join(".");
					var Img = new iG_Image(status.name, {title: T, date: Date.parse(new Date()), id: status.id, src: status.url});
					Img.onComplete = function(){ that.save(); };
					that.registerImage(Img);
					that.save(true); //update preview
					if(typeof(onComplete) == 'function')
						onComplete();
				};
				var Dat = "action=PSaddImage&path="+rawEscape(Data.path)+"&name="+rawEscape(Data.name);
				$jQ.post(that.Acturl, Dat, onAdd);
			}
		};
		var _saveSesion = function(Json)
		{
			var onSave = function(Data)
			{
				var status = null;
				try{ eval(Data) }catch(E){ return; }
				if(status && status.status!="ok")
					Noter.display(status.message);
			};
			var Data = "action=PSsaveSession&datastr="+rawEscape(Json);
			$jQ.post(that.Acturl, Data, onSave);
		};
		var _export = function()
		{
			if(_EditPane.ActImages.length == 0)
			{
				Noter.display("Try adding at least one image to your gallery before saving ;)");
				return;
			}
			if(!Validator.checkText(_Gallery.TitleInpt))
			{
				Noter.display("Sorry, but title can contain only alphanumeric characters (A-z 0-9) and punctuation.");
				return;
			}
			if(that.Saving)
			{
				Noter.display("Saving...", "repl_gallerysaving");
				return;
			}
			that.Saving = true;			
			that.SaveIco = PlaceAjaxIcon(_BtnSave);
			var GalWidth = that.getGalWidth();
			var Items = [];
			var LastImg = null;
			for(var I=0; I<that.Images.length; I++)
				if(!that.Images[I].StockMode && !that.Images[I].Destroyed) //not Stock and not removed image ->
				{
					Items.push(that.Images[I].createThumb(['custom'], GalWidth, true));
					LastImg = that.Images[I]; //will be the last image in the processing list
				}
			if(LastImg) //continue with save when all images processed
				LastImg.onComplete = function(){ _finishExport() };
			else //or if no images to process step on right away
			{
				_finishExport();
				return;
			}
			if(G_PS_GDEnabled)
			{
				var Data = "action=PSthumbnailImage&images=[" + Items.join(', ') + "]";
				$jQ.post(that.Acturl, Data, SWFP_onThumbnailComplete);
			}
			else
				G_PS_ImProcessor.createThumbnails(Items, 'custom', GalWidth);
		}	
		var _setImgSrcs = function(Id, Obj)
		{
			for(var I=0; I<that.Images.length; I++)
				if(that.Images[I].Iid == Id)
				{
					if(Obj.thumbnails)
					{
						that.Images[I].Thumbnails = Obj.thumbnails;						
						that.Images[I].Mainsrc = unescape(Obj.thumbnails.original);
					}
					break;
				}
		};
		var _clearImage = function(Id)
		{
			for(var I=0; I<that.Images.length; I++)
				if(that.Images[I].Iid == Id)
				{
					that.Images.splice(I, 1);
					break;
				}
		};
		var _finishExport = function()
		{
			var onUpd = function(Data)
			{
				that.SaveIco.remove();
				var status = null;
				that.Saving = false;
				try{eval(Data)} catch(E){ 
					Noter.display('Oops! We\'re having some problems. <a href="contact@picturesurf.org">Please tell us more</a>.'); return;
				};
				if(status && status.status == "ok")
				{
					_Gallery.Gid = status.gid;
					_Gallery.Code = status.code;
					_Gallery.Dateup = status.updated;
					//cleanup deleted images
					for(var I=0; I<Dellist.length; I++)
						_clearImage(Dellist.id);
					if(status.images)
						for(var I=0; I<status.images.length; I++)
						{
							_setImgSrcs(status.images[I].id, status.images[I]);
						}
					var Value = '[PSGallery='+_Gallery.Code+']';
					var Srch = Value.replace("[", "\\[").replace("]", "\\]");
					if(typeof (FCKInstance) != 'undefined')
					{
						var Html = FCKInstance.GetHTML();
						if(Html.search(Srch) == -1)
							FCKInstance.InsertHtml(Value);
					}
					else
					{
						var Editor = document.getElementById('content');
						var Html = Editor.value;
						if(window.switchEditors)
							switchEditors.go('content');
						if(Html.search(Srch)==-1)
							Editor.value = Html+Value;
						Editor.focus();
					}
					_updateEmbedBox(_Gallery.Code);
				}
				else
					Noter.display(status.message);
			};
			var Json = that.save(true);
			var Dellist = ['empty']; //need a placeholder cause first element get's lost in post vars
			for(var I=0; I<that.Images.length; I++)
				if(that.Images[I].Destroyed)
				{
					Dellist.push({id: that.Images[I].Iid, thumbnails: that.Images[I].Thumbnails});
				}
			var Data = "action=PSsaveGallery&gid="+_Gallery.Gid + js2php({destrIms: Dellist}) + "&datastring=" + rawEscape(Json);
			$jQ.post(that.Acturl, Data, onUpd);
		};
		
		this.registerImage = function(Img)
		{
			var present = false;
			$jQ(this.Images).each(function(I, El){ if(El.iid && El.iid == Img.iid) present = true; });
			if(present) //exit if image already added
				return;
			this.Images.push(Img);
			_EditPane.addImage(Img);
		};
		this.updatePreview = function(Data)
		{
			if(!Data.title)
				Data.title = _PreviewDefaultData.title;
			if(Data.ims.length == 0)
			{
				var prev = _PreviewDefaultData.ims;
				if(Data.data && Data.data.thar)
				{
					var thr = Data.data.thar.split("x");
					if(thr.length == 2)
					{
						var newprev = [];
						var total = 1*thr[1];
						for(var I=0; I<total; I++)
							newprev.push(prev[I%5]);
						prev = newprev;
					}
				}
				Data.ims = prev;
			}
			_Preview.data = Data;
			var cssdata = rawEscape(unescape( toJson(Data.data) ));
			if(_Preview.display)
				_Preview.redrawDisplay(cssdata);
			else if(_Preview.main)
				_Preview.initDisplay();
		};
		this.save = function(noDestroyedAndSession)
		{
			var Json = "Gallery = { ";
			Json+= _saveJson();
			var ImgStrArr = [];
			var ImgPrevArr = [];
			//$jQ(_EditPane.Images).each(function(I, El){ if(El.Destroyed) that.Images = $jQ.arrayRemove(El, that.Images) });
			for(var I=0; I<_EditPane.Images.length; I++)
			{
				var ImgJson = _EditPane.Images[I]._getJson();
				if(!_EditPane.Images[I].Destroyed || !noDestroyedAndSession)
					ImgStrArr.push(ImgJson);
				if(!_EditPane.Images[I].Destroyed)
					ImgPrevArr.push(ImgJson);
			}
			var PrJson = Json+", \"ims\": [" + ImgPrevArr.join(",") + "]}";
			Json+= ", \"ims\": [" + ImgStrArr.join(",") + "]}";
			var Gallery = null;
			try{eval(Json)}catch(E){ Noter.display('Oops! We\'re having some problems. <a href="contact@picturesurf.org">Please tell us more</a>.'); return; };
			try{eval(PrJson)}catch(E){};
			if(!noDestroyedAndSession)
				_saveSesion(Json);
			this.updatePreview(Gallery);
			return Json;
		};
		this.setRows = function(Value, DontUpdate)
		{
			var Splt = _Gallery.ThumbArrangment.split('x');
			if(Value == Splt[0]) //if same value - do nothing
				return; 
			_Gallery.ThumbArrangment =  Value + 'x' + Splt[1];
			if(!DontUpdate)
				this.save();
		};
		this.setCols = function(Value, DontUpdate)
		{
			var Splt = _Gallery.ThumbArrangment.split('x');
			if(Value == Splt[1]) //if same value - do nothing
				return; 
			_WidthSel.val(Value);
			_Gallery.ThumbArrangment = Splt[0] + 'x' + Value;
			if(!DontUpdate)
				this.save();
		};
		this.getGalWidth = function(Cols)
		{
			if(!Cols)
				Cols = _Preview.cols;
			return Cols*84-5;			
		};
		this.showEdit = function()
		{
			_EditPane.open();
		};
	};
	
/*
 * Edit page controls
 */
	PSGalleryEditPane = function(_Page, Main)
	{
		var that = this;
		var _Main = Main;
		var _GreyColor = "#7D7D7D";
		var _InvKeys = [9, 16, 17, 18, 33, 34, 35, 36, 37, 38, 39, 40, 91];
		var _ImgInRow = 5;
		var _ImagesBlock = _Page.find(".psg-imagesblock").click(function(E){ that._deselectAll(); _Pars.updateNote(); });
		var _ImagesUl = _ImagesBlock.find(".images");
		var _EditLink = $jQ("#psg-imgs-edit").click(function(){ that.open(); return false; });
		var _Box = new BoxLibrary(_ImagesBlock, ".b-image-link");
		_Box.onselect = function(Thmb){ that.selectImage(Thmb.get(0).Main, true); _Pars.updateNote(); };
		_Box.ondeselect = function(Thmb){ that.deselectImage(Thmb.get(0).Main, true); _Pars.updateNote(); };
		_Box.onstart = function(Thmb){ that._deselectAll(); };
		var _RemoveBtn = $jQ("#psg-imgs-remove").click(function(E){ that.deleteImages(); return false; });
		var _Pars = {
			Uns: {},
			Note: _Page.find('#psg-par-note'),
			Title: _Page.find('#psg-par-title').blur(function(){ _Pars.onBlur() }),
			TitleL: _Page.find('#psg-par-title-label'),
			Descr: _Page.find('#psg-par-descr').blur(function(){ _Pars.onBlur() }),
			DescrL: _Page.find('#psg-par-descr-label'),
			Tags: _Page.find('#psg-par-tags').blur(function(){ _Pars.onBlur() }),
			TagsL: _Page.find('#psg-par-tags-label'),
			onBlur: function()
			{
				if(_Pars.Uns.Title)
					that.setTitle();
				if(_Pars.Uns.Descr)
					that.setDescr();
				if(_Pars.Uns.Tags)
					that.setTags();
			},
			updateNote: function()
			{
				if(that.ActImages.length == 0)
					this.Note.css("display", "none");
				else
					this.Note.css("display", "block");
				var Count = that.Selected.length;
				if(Count == 0)
				{
					this.Note.html("Select one or more images to begin labeling.");
					this.toggleGreyOut(true);
				}
				else
				{
					this.Note.html(Count+" image"+(Count>1?"s are":" is")+" selected for labeling.");
					this.toggleGreyOut(false);
				}
				if(Count==1)
				{
					that.loadImgData(that.Selected[0]);
					this.toggleMultiMode(false);
				}
				if(Count > 1)
				{
					this.Title.val("");
					this.Descr.val("");
					this.Tags.val("");
					this.toggleMultiMode(true);
				}
				for(var I=0; I<that.Selected.length; I++)
					if(that.Selected[I].StockMode == 'Picapp')
					{
						this.Descr.get(0).disabled = true;
					}
			},
			toggleGreyOut: function(mode)
			{
				if(mode)
				{
					_RemoveBtn.addClass("disabled");
					this.TitleL.css("color", _GreyColor);
					this.DescrL.css("color", _GreyColor);
					this.TagsL.css("color", _GreyColor);
					this.Title.addClass("g-disabled");
					this.Descr.addClass("g-disabled");
					this.Tags.addClass("g-disabled");
					this.Title.get(0).disabled = true;
					this.Descr.get(0).disabled = true;
					this.Tags.get(0).disabled = true;
					this.Title.val('');
					this.Descr.val('');
					this.Tags.val('');
					if(this.InMultiMode)
						this.toggleMultiMode(false);
				}
				else
				{
					_RemoveBtn.removeClass("disabled");
					this.TitleL.css("color", "");
					this.DescrL.css("color", "");
					this.TagsL.css("color", "");
					this.Title.removeClass("g-disabled");
					this.Descr.removeClass("g-disabled");
					this.Tags.removeClass("g-disabled");
					this.Title.get(0).disabled = false;
					this.Descr.get(0).disabled = false;
					this.Tags.get(0).disabled = false;
				}
			},
			toggleMultiMode: function(On)
			{
				this.InMultiMode = On;
				if(On && this.TitleL.html() != "Replace titles:")
				{
					this.TitleL.html("Replace titles:");
					this.DescrL.html("Add to existing descriptions:");
					this.TagsL.html("Add to existing tags:");
				}
				if(!On && this.TitleL.html() != "Title:")
				{
					this.TitleL.html("Title:");
					this.DescrL.html("Description:");
					this.TagsL.html("Tags:");
				}
			}	
		};
		var escapeEnter = function(E){ if(E.keyCode == 13){ return false; }};
		_Pars.Title.keydown(escapeEnter).keyup(function(E){ if(E.keyCode  && $jQ.inArray(E.keyCode , _InvKeys) == -1) _Pars.Uns.Title = true });
		_Pars.Descr.keydown(escapeEnter).keyup(function(E){ if(E.keyCode  && $jQ.inArray(E.keyCode , _InvKeys) == -1) _Pars.Uns.Descr = true });
		_Pars.Tags.keydown(escapeEnter).keyup(function(E){ if(E.keyCode  && $jQ.inArray(E.keyCode , _InvKeys) == -1) _Pars.Uns.Tags = true });
		
		var _ImgDnD = {
			Snap: 5,
			Drops: [],
			DropZone: $jQ('<li class="psg-image-drop-zone"></li>'),
			inDropZone: function(E, Li, Over)
			{
				if(Over.get(0) != _ImagesBlock.get(0))
					_ImgDnD.DropZone.insertBefore(Over);
				else
					_ImgDnD.DropZone.appendTo(_ImagesUl);
			},
			outDropZone: function(E, Li, Over)
			{
				if(_ImgDnD.DropZone.parent().length)
					_ImgDnD.DropZone.appendTo(_ImagesUl);
			},
			onSnap: function(E, Obj)
			{
				_ImgDnD.DropZone.appendTo(_ImagesUl);
				Obj.Drag.Options.Droppables = $jQ.grep($jQ.extend([], _ImgDnD.Drops), function(N, I){return N.get(0) != Obj.get(0)});
				Obj.Pos = Obj.position(_ImagesBlock);
				Obj.css({'position': 'absolute', 'z-index': '1000'});
				Obj.Drag.recalcCoords();
			},
			onDrag: function(E, Obj)
			{
				var T = Obj.Pos.top + Obj.Drag.Mouse.Now.Y - Obj.Drag.Mouse.Start.Y;
				var L = Obj.Pos.left + Obj.Drag.Mouse.Now.X - Obj.Drag.Mouse.Start.X;
				Obj.css({top: T, left: L}); //, opacity: 0.7
			},
			onDrop: function(E, Li, Over)
			{
				Li.insertBefore(_ImgDnD.DropZone);
				_ImgDnD.DropZone.remove();
				Li.css({ top: "", left: "", position: "", width: "", 'z-index': "" });
				that._saveOrder();
				_Main.save();
				_Box.analize();
				return true;
			}
		}
		this.Images = [];
		this.ActImages = [];
		this.Selected = [];
		$jQ(document).mousedown( function(){ _Pars.onBlur(); } );
		//$jQ(document).keypress( function(E){ _keypress(E, that.LastSelected, 'Edtthmb', function(Img, Force){ that.selectImage(Img, Force) }) } );

		var _search = function(Img, Mode, Lsel, Thmbname)
		{
			var Item = Lsel[(Thmbname?Thmbname:"Edtthmb")].get(0).Li;
			var Tthmb = Img[(Thmbname?Thmbname:"Edtthmb")].get(0).Li;
			var Buff = [];
			while(Item.get(0))
			{
				if(Item.get(0) == Tthmb.get(0))
				{
					return Buff;
				}
				Buff.push(Item.find(":first").get(0).Main);
				Item = (Mode=="back"?Item.prev():Item.next());
			}
			return null;
		};
		var _keypress = function(E, Lsel, Thmbname, SelImage)
		{
			var Target = null;
			var IsMulti = null;
			if(!Lsel)
				return false;
			if(E.keyCode == "a" && E.ctrlKey)
			{
				this.selectAll(true);
				return false;
			}
			if(E.keyCode==37)
				Target = Lsel[Thmbname].get(0).Li.prev();
			if(E.keyCode==39)
				Target = Lsel[Thmbname].get(0).Li.next();
			if(E.keyCode==38)
			{
				Target = Lsel[Thmbname].get(0).Li.prev();
				for(var I=1; I<_ImgInRow; I++)
					if(Target)
						Target = Target.prev();
			}
			if(E.keyCode==40)
			{
				Target = Lsel[Thmbname].get(0).Li.next();
				for(var I=1; I<_ImgInRow; I++)
					if(Target)
						Target = Target.next();
			}
			if(!Target.length)
				return false;
			if(E.shiftKey && Lsel)
			{
				var Imthmbs = _search(Target.find(':first').get(0).Main, "forward", Lsel, Thmbname);
				if(!Imthmbs)
					Imthmbs = _search(Target.find(':first').get(0).Main, "back", Lsel, Thmbname);
				for(var I=0; I<Imthmbs.length; I++)
					SelImage(Imthmbs[I], true);
			}
			SelImage(Target.find(':first').get(0).Main, E.shiftKey||E.ctrlKey);
			return false;
		};
		
		this.open = function()
		{
			if(_Main.ActivePane)
				_Main.ActivePane.close();
			_Page.css('display', 'block');
			_EditLink.addClass('active');
			_RemoveBtn.css("display", "block");
			_Pars.updateNote();
			_Box.analize();
			_Main.ActivePane = this;
		};
		this.close = function()
		{
			_Page.css('display', 'none');
			_EditLink.removeClass('active');
			_RemoveBtn.css("display", "none");
		};
		this.onChange = function()
		{
			if(this.NoSave)
				return;
			_Main.save();
		};
		this.addImage = function(Img)
		{
			this.Images.push(Img);
			if(Img.Destroyed) //exit if image was previously deleted
				return;
			var onselect = function(obj, E)
			{
				if(E.shiftKey && that.LastSelected && obj != that.LastSelected)
				{
					var Imthmbs = that._search(obj, "forward", that.LastSelected);
					if(!Imthmbs)
						Imthmbs = that._search(obj, "back", that.LastSelected);
					that._deselectAll();
					for(var I=0; I<Imthmbs.length; I++)
						that.selectImage(Imthmbs[I], true);
				}
				that.selectImage(obj, E.shiftKey||E.ctrlKey);
				_Pars.updateNote();
			};
			var Li = new $jQ('<li class="b-image-thumb"></li>').appendTo(_ImagesUl);
			Li.draggable({
				Snap: _ImgDnD.Snap,
				onSnap: _ImgDnD.onSnap,
				onDrag: _ImgDnD.onDrag,
				onBeforeDrop: _ImgDnD.onDrop,
				onEmpty: _ImgDnD.onDrop,
				Droppables: _ImgDnD.Drops
			}).bind('over', _ImgDnD.inDropZone).bind('leave', _ImgDnD.outDropZone);
			Li.css({ top: "", left: "", position: "" });
			_ImgDnD.Drops.push(Li);
			var Thmb = Img.drawThumb(onselect);
			Thmb.appendTo(Li);
			var num = this.ActImages.length;
			var ondblclick = function(E)
			{
				E.stopPropagation();
				_Main.preview.Popen(num);
				return false;
			}
			this.ActImages.push(Img);
			Img.Edtthmb = Thmb;
			Img.Edtthmb.get(0).Li = Li;
			Img.InList.push(Li);
			Thmb.P.dblclick(function(E){ ondblclick(E) });
			if(this.ActImages.length==1)
			{
				this.selectImage(Img);
				_Pars.updateNote();
			}
			if(!Img.nosave)
				_Box.analize();
		};
		this.selectImage = function(Img, Force)
		{
			_Pars.onBlur();
			if(!Force)
				this._deselectAll();
			$jQ.arrayInclude(Img, this.Selected);
			Img.Edtthmb.addClass("selected");
			Img.Edtthmb.I.css("opacity", 1);
			this.LastSelected = Img;
		};
		this.deselectImage = function(Img)
		{
			Img.Edtthmb.removeClass("selected");
			this.Selected = $jQ.arrayRemove(Img, this.Selected);
			Img.updateRichness();
		};
		this.selectAll = function()
		{
			if(to)
				$jQ(this.Images).each(function(I, Img){ that.selectImage(Img, true) });
			this._updateNote();
		};
		this._deselectAll = function()
		{
			while(this.Selected.length > 0)
				this.deselectImage(this.Selected[0]);
		};
		this._saveOrder = function()
		{
			var Order = [];
			var List = _ImagesUl.find("li");
			for(var I=0; I<List.length; I++)
			{
				var TH = List[I].firstChild;
				if(TH && TH.Main)
					Order.push(TH.Main);
			}
			this.Images = Order;
		};
		this.loadImgData = function(Img)
		{
			_Pars.Title.val(Img.Title);
			_Pars.Descr.val(Img.Descr);
			_Pars.Tags.val(Img.Tags.join(", "));
		};
		this.setTitle = function()
		{
			if(!this.Selected.length)
				return;
			var Title = _Pars.Title.val();
			$jQ(this.Selected).each(function(I, Img){ Img.setTitle(Title) });
			_Pars.Uns.Title = false;				
			this.onChange();
		};
		this.setDescr = function()
		{
			if(!this.Selected.length)
				return;
			var BaseDescr = _Pars.Descr.val();
			for(var I=0; I<this.Selected.length; I++)
			{
				var Descr = BaseDescr;
				if(this.Selected.length>1)
					Descr = (this.Selected[I].sdescr?this.Selected[I].sdescr+"\n":"") + Descr;
				this.Selected[I].setDescr(Descr); 
			};
			_Pars.Uns.Descr = false;				
			this.onChange();
		};
		this.setTags = function()
		{
			if(!this.Selected.length)
				return;
			var BaseTags = _Pars.Tags.val().replace(/[\r\n]/g, " ").split(/ *, */);
			for(var I=0; I<this.Selected.length; I++)
			{
				var Tags = $jQ.extend([], BaseTags);
				if(this.Selected.length > 1)
					Tags = $jQ.extend(Tags, this.Selected[I].stags).unique();
				this.Selected[I].setTags(Tags);
			}
			_Pars.Uns.Tags = false;				
			this.onChange();
		};
		this.onImgDelete = function(Img)
		{
			if(Img.Edtthmb)
			{
				Img.Edtthmb.destroy();
				Img.Edtthmb.get(0).Li.destroy();
				Img.Edtthmb.get(0).Li = null;
				Img.Edtthmb = null;
			}
			this.Images = this.Images.erase(Img);
		};
		this.deleteImages = function()
		{
			var Sel = $jQ.extend([], this.Selected);
			var undo = function()
			{
				$jQ(Sel).each(function(I, Img){ 
					Img.Destroyed = false;
					Img.Edtthmb.get(0).Li.css("display", "block");
					that.ActImages.push(Img);
					if(Img.StockMode)
						_FindPane.insIntoList(Img.StockParam, Img.StockMode);
				});
				_Box.analize();
				_Pars.updateNote();
				_Main.save();
			};
			var finish = function()
			{
				$jQ(Sel).each(function(I, Img){ Img.destroy() });
			};
			$jQ(Sel).each(function(I, Img){
				that.ActImages = $jQ.arrayRemove(Img, that.ActImages);
				that.deselectImage(Img);
				Img.Edtthmb.get(0).Li.css("display", "none");
				Img.Destroyed = true;
				if(Img.StockMode)
					_FindPane.rmFromList(Img.StockParam, Img.StockMode);
				if(Img == Sel[Sel.length-1])
				{
					_Box.analize();
					_Main.save();
					Img.last = true;
				}
			});
			_Pars.updateNote();
			var Msg = (Sel.length>1?Sel.length+" Images":"Image")+" deleted.";
			Noter.display(Msg, "repl_imgdel", {Name: "Undo", func: undo, fina: finish});
		};
	};
/*
 * Settings page controls
 */	
	PSGallerySettingsPane = function(_Page, Main)
	{
		var that = this;
		var _Main = Main;
		var _PrevPane = null;
		var _SettsLink = $jQ("#psg-imgs-settings").click(function(){ that.open(); return false;});
		var _Panels = {
			GeneralLink: _Page.find("#psg-settings-tab-general"),
			GeneralPane: _Page.find("#psg-settings-pane-general"),
			StockLink: _Page.find("#psg-settings-tab-stock"),
			StockPane: _Page.find("#psg-settings-pane-stock")
		};
		_Panels.GeneralLink.click( function(){ 
			_Panels.StockPane.css('display', 'none');
			_Panels.GeneralPane.css('display', 'block');
			_Panels.StockLink.removeClass('active');
			_Panels.GeneralLink.addClass('active');
			return false;
		} );
		_Panels.StockLink.click( function(){
			_Panels.GeneralPane.css('display', 'none');
			_Panels.StockPane.css('display', 'block');
			_Panels.GeneralLink.removeClass('active');
			_Panels.StockLink.addClass('active');
			return false;
		} );
		var _BtnSetsSave = _Page.find("#psg-sets-save").click( function(){ that.save() });
		var _BtnSetsCancel = _Page.find("#psg-sets-cancel").click( function(){ _cancel() });
		var _SettsParams = [];
		_SettsParams['Width'] = _Page.find("#psg-sets-width").change( function(){ _updateWidth() } );
		_SettsParams['WidthNote'] = _Page.find("#psg-sets-width-px");
		_SettsParams['Height'] = _Page.find("#psg-sets-height").change( function(){ _updateHeight() } );
		_SettsParams['HeightNote'] = _Page.find("#psg-sets-height-num");
		_SettsParams['IsShowEmail'] = _Page.find("#psg-sharing-email");
		_SettsParams['IsShowFB'] = _Page.find("#psg-sharing-fb");
		_SettsParams['IsShowPL'] = _Page.find("#psg-sharing-pl");
		_SettsParams['IsPages'] = _Page.find("#psg-sets-view-page");
		_SettsParams['IsAjax'] = _Page.find("#psg-sets-view-ajax");
		_SettsParams['IsInline'] = _Page.find("#psg-sets-view-inline");
		_SettsParams['StockImages'] = {
			'PicappOn': _Page.find("#psg-sets-stock-picapp-on"),
			'PicappOff': _Page.find("#psg-sets-stock-picapp-off"), 
			'FotoglifOn': _Page.find("#psg-sets-stock-fotoglif-on"),
			'FotoglifOff': _Page.find("#psg-sets-stock-fotoglif-off")
		};
		
		var _load = function()
		{
			if(typeof(G_PS_GallerySettings) == "object")
			{
				if(!G_PS_GallerySettings['IsPages'] && !G_PS_GallerySettings['IsAjax'] && !G_PS_GallerySettings['IsInline'])
					G_PS_GallerySettings['IsPages'] = true;
				_SettsParams['Width'].val(G_PS_GallerySettings['Width']);
				_SettsParams['WidthNote'].html(_Main.getGalWidth(G_PS_GallerySettings['Width']));
				_SettsParams['Height'].val(G_PS_GallerySettings['Height']);
				_SettsParams['HeightNote'].html(G_PS_GallerySettings['Height']);
				_SettsParams['IsShowEmail'].get(0).checked = G_PS_GallerySettings['IsShowEmail'];
				_SettsParams['IsShowFB'].get(0).checked = G_PS_GallerySettings['IsShowFB'];
				_SettsParams['IsShowPL'].get(0).checked = G_PS_GallerySettings['IsShowPL'];
				_SettsParams['IsPages'].get(0).checked = G_PS_GallerySettings['IsPages'];
				_SettsParams['IsAjax'].get(0).checked = G_PS_GallerySettings['IsAjax'];
				_SettsParams['IsInline'].get(0).checked = G_PS_GallerySettings['IsInline'];
				var Stock = G_PS_GallerySettings['StockImages'].split(';');
				if($jQ.inArray('Picapp', Stock) != -1)
					_SettsParams['StockImages']['PicappOn'].get(0).checked = true;
				else
					_SettsParams['StockImages']['PicappOff'].get(0).checked = true;
				if($jQ.inArray('Fotoglif', Stock) != -1)
					_SettsParams['StockImages']['FotoglifOn'].get(0).checked = true;
				else
					_SettsParams['StockImages']['FotoglifOff'].get(0).checked = true;
			}
			else
				Noter.display('Oops! Plugin settings can\'t be loaded. <a href="contact@picturesurf.org">Please tell us more</a>.');
		};
		var _cancel = function()
		{
			_load();
			_PrevPane.open();
		};
		var _updateHeight = function()
		{
			_SettsParams['HeightNote'].html(_SettsParams['Height'].val());
		};
		var _updateWidth = function()
		{
			_SettsParams['WidthNote'].html(_Main.getGalWidth(_SettsParams['Width'].val()));
		};

		this.open = function()
		{
			_PrevPane = _Main.ActivePane;
			//_Main.ActivePane.close();
			_load();
			_SettsLink.addClass('active');
			_Page.css("display", "block");
			_Main.ActivePane = this;
		};
		this.close = function()
		{
			_SettsLink.removeClass('active');
			_Page.css("display", "none");
		};
		this.getParams = function()
		{
			return _SettsParams;
		};
		this.save = function()
		{
			var Stock = [];
			if(_SettsParams['StockImages']['PicappOn'].get(0).checked)
				Stock.push('Picapp');
			if(_SettsParams['StockImages']['FotoglifOn'].get(0).checked)
				Stock.push('Fotoglif');
			G_PS_GallerySettings['Width'] = _SettsParams['Width'].val();
			G_PS_GallerySettings['Height'] = _SettsParams['Height'].val();
			G_PS_GallerySettings['IsShowEmail'] = _SettsParams['IsShowEmail'].get(0).checked;
			G_PS_GallerySettings['IsShowFB'] = _SettsParams['IsShowFB'].get(0).checked;
			G_PS_GallerySettings['IsShowPL'] = _SettsParams['IsShowPL'].get(0).checked;
			G_PS_GallerySettings['IsPages'] = _SettsParams['IsPages'].get(0).checked;
			G_PS_GallerySettings['IsAjax'] = _SettsParams['IsAjax'].get(0).checked;
			G_PS_GallerySettings['IsInline'] = _SettsParams['IsInline'].get(0).checked;
			G_PS_GallerySettings['StockImages'] = Stock.join(';');
			_Main.setCols(G_PS_GallerySettings['Width']);
			_Main.setRows(G_PS_GallerySettings['Height']);
			var Data = "action=PSsaveSettings&" + js2php(G_PS_GallerySettings);
			if(_SettsLink.hasClass('active'))
				var Ico = PlaceAjaxIcon(_BtnSetsSave);
			var onUpd = function(Data)
			{
				var status = null;
				if(Ico)
					Ico.remove();
				try{eval(Data)} catch(e){};
				if(!status)
				{
					Noter.display("Oops! We're having some technical difficulties. Please try again soon.");
					return false;
				}
				if(status.status  == "fail")
				{
					Noter.display(status.message);
					return false;
				}
				else
					if(_PrevPane)
						_PrevPane.open();
			}
			$jQ.post(_Main.Acturl, Data, onUpd);
		};
	};
/*
 * Find page controls
 */	
	var PSGalleryFindPane = function(_Page, _Main)
	{
		var that = this;
		var _StockModes = G_PS_GallerySettings['StockImages'].split(';');
		var _FindLink = $jQ('#psg-imgs-find').click(function(){ that.open(); return false; });
		var _InptSearch = _Page.find('#psg-search-inpt').keydown(function(E){ if(E.keyCode == 13){ _search(); return false; }});
		var _SelSource = _Page.find('#psg-search-source');
		var _BtnSerach = _Page.find('#psg-search-btn').click(function(){ _search(); return false; });
		var _ImagesDiv = _Page.find('.psg-search-imagesblock').scroll( function(){ _scrollSearch()} );
		var _ImagesUl = _Page.find('.images');
		var _SearchPage = 1;
		var _SearchExosted = false;
		var _Adding = false;
		var _AddedOpacity = 0.6;
		var _Added = {Picapp: [], Fotoglif: []};
		this.Images = [];
		_InptSearch.focus(function(){ var Inp = $jQ(this); Inp.hasClass('shady')?Inp.val('').removeClass('shady'):null; });
		_InptSearch.blur(function(){ var Inp = $jQ(this); Inp.val()==''?Inp.addClass('shady').val('Search for images online'):null; });
		if(_InptSearch.val()=='')
			_InptSearch.val("Search for images online");
		
		//this needs to be global! So that callback can find closued PSGalleryFindPane context
		_prcSearch = function(Data)
		{
			that.Searching = false;
			that.SearchIco.remove();
			var Mode = _SelSource.val();
			if(!Mode)
				return;
			if(Data.error)
			{
				Noter.display(Data.error);
				return;
			}
			var List = [];
			if(Mode == 'Picapp')
				List = Data.ImageInfo;
			if(Mode == 'Fotoglif')
				List = Data.response;
			if(!List || List.length == 0)
			{
				_SearchExosted = true;
				if(that.Images.length < 1)
					Noter.display('No images were found.');
				return;
			}
			for(var I=0; I<List.length; I++)
			{
				var Itm = List[I];
				var Img = _refineImageData(Mode, Itm)
				Img.Li = _drawThumb(Img).appendTo(_ImagesUl);
				that.Images.push(Img);
			}
			if(Img && that.Images.length < 70)
				_searchMore();
		};
		var _scrollSearch = function()
		{
			if(that.Searching)
				return;
			var El = _ImagesDiv.get(0);
			if(El.scrollTop + El.offsetHeight > El.scrollHeight - 100)
				_searchMore();
		};
		var _addImage = function(Data)
		{
			if(_Adding)
				return;
			if($jQ.inArray(Data.StockParam, _Added[Data.StockMode]) != -1) //if already added
				return; //exit
			var onAdd = function(Resp)
			{
				_Adding = false;
				var status = null;
				try{ eval(Resp) }catch(E)
				{
					Noter.display("Oops! We're having some technical difficulties. Please try again soon.");
					return;
				}
				if(status && status.status!="ok")
				{
					Noter.display(status.message);
					return;
				}
				that.insIntoList(Data.StockParam, Data.StockMode);
				Data.date = Date.parse(new Date());
				Data.id = status.id;
				var Img = new iG_Image(status.name, Data, true);
				_Main.registerImage(Img);
				_Main.save();
			};
			_Adding = true;
			var Dat = "action=PSaddImage&path="+rawEscape(Data.src)+"&name="+rawEscape(Data.title)+"&stock="+Data.StockMode;
			$jQ.post(_Main.Acturl, Dat, onAdd);
		};
		var _refineImageData = function(Mode, Img)
		{
			if(Mode == 'Picapp')
			{
				var Title = Img.imageTitle;
				var Descr = Img.description;
				var Thumb = Img.urlImageThumnail;
				var Src = Img.urlImageFullSize;
				var Param = Img.imageId;
				var Add = Img.photographerName;
			}
			if(Mode == 'Fotoglif')
			{
				var Title = Img.description.substr(0, 30);
				var Descr = Img.description;
				var Thumb = 'http://gallery.fotoglif.com/thumbnails/thumbnail_' + Img.image_uid + '.jpg';
				var Src = null;
				var Param = Img.image_uid;
				var Add = null;
			}
			return {thumbnails: {original: Src, ST: Thumb}, src: Src, title:  Title, descr:  Descr, StockMode: Mode, StockParam: Param, StockAdd: Add};
		};
		var _markAsAdded = function(Li)
		{
			Li.find(':first').css('opacity', _AddedOpacity);
			var Added = $jQ('<div class="b-image-added"></div>').appendTo(Li);
		};
		var _unmarkAdded = function(Li)
		{
			Li.find(':first').css('opacity', '');
			Li.find('b-image-added').remove();
		};
		var _drawThumb = function(Img)
		{
			var Li = $jQ('<li class="b-image-thumb"></li>');
			var Thbox = $jQ('<p class="b-image-link"></p>').appendTo(Li);
			Thbox.P = $jQ('<a href="#" title="' + Img.title + '"></a>').appendTo(Thbox);
			Thbox.Si = $jQ('<span class="image-holder"></span>').appendTo(Thbox.P);
			Thbox.I = $jQ('<img src="' + Img.thumbnails.ST + '" height="72" alt=""/>').appendTo(Thbox.Si);
			Thbox.S = $jQ('<span class="image-Title"></span>').css({display: (Img.title?"inline":"none")}).appendTo(Thbox.P);
			Thbox.S.html(Img.title);
			Thbox.P.get(0).Data = Img;
			Thbox.P.click( function(){ _addImage(this.Data); return false; } );
			if($jQ.inArray(Img.StockParam, _Added[Img.StockMode]) != -1)
				_markAsAdded(Li);
			return Li;
		};
		var _getSearchUrl = function(Mode, Pattern, Page)
		{
			var ProxyUrl = 'http://www.picturesurf.org/gallery_data/findimages.php?';
			if(Mode == 'Picapp')
			{
				var Call = 'Search';
				var Query = 'term';
				var Ads = '&cats=&clrs=&oris=&types=&mp=&post=&sort=&totalRecords=70';
			}
			if(Mode == 'Fotoglif')
			{
				var Call = rawEscape('image/search');
				var Query = 'query';
				var Ads = '';
			}
			Pattern = rawEscape(Pattern);
			return ProxyUrl + 'PSGmode=' + Mode + '&PSGcall=' + Call + '&PSGcallback=' + '_prcSearch' + '&page=' + Page + '&' + Query + '=' + Pattern + Ads;
		};
		var _clearResults = function()
		{
			_ImagesUl.html('');
			that.Images = [];
		};
		var _searchMore = function()
		{
			if(_SearchExosted)
				return;
			var Mode = _SelSource.val();
			if(!Mode)
				return;
			that.Searching = true;
			var Url = _getSearchUrl(Mode, _InptSearch.val(), _SearchPage++);
			if(that.SearchIco)
				that.SearchIco.remove();
			that.SearchIco = PlaceAjaxIcon(_BtnSerach);
			$jQ.getScript(Url);
		};
		var _search = function()
		{
			if(!Validator.checkEmpty(_InptSearch) || _InptSearch.hasClass('shady'))
			{
				Noter.display('Place some text to search for ;)');
				return;
			}
			_SearchExosted = false;
			_SearchPage = 1;
			_clearResults();
			_searchMore();
		};
		var _updateSources = function()
		{
			_StockModes = G_PS_GallerySettings['StockImages'].split(';');
			_SelSource.html('');
			for(var I=0; I<_StockModes.length; I++)
				$jQ('<option value="' + _StockModes[I] + '">' + _StockModes[I] + '</option>').appendTo(_SelSource);
		};

		this.insIntoList = function(Id, Mode)
		{
			if(!_Added[Mode])
				throw 'Invalid stock image mode';
			$jQ.arrayInclude(Id, _Added[Mode]);
			for(var I=0; I<this.Images.length; I++)
				if(this.Images[I].StockParam == Id)
					_markAsAdded(this.Images[I].Li);
		};
		this.rmFromList = function(Id, Mode)
		{
			if(!_Added[Mode])
				throw 'Invalid stock image mode';
			$jQ.arrayRemove(Id, _Added[Mode]);
			for(var I=0; I<this.Images.length; I++)
				if(this.Images[I].StockParam == Id)
					_unmarkAdded(this.Images[I].Li);
		};
		this.open = function()
		{
			if(_Main.ActivePane)
				_Main.ActivePane.close();
			_Page.css('display', 'block');
			_FindLink.addClass('active');
			_Main.ActivePane = this;
			_updateSources();
		};
		this.close = function()
		{
			_Page.css('display', 'none');
			_FindLink.removeClass('active');
		};
	};

	var GalleryIns = new PSGallery();